unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Button2: TButton;
    Edit2: TEdit;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button3: TButton;
    Label1: TLabel;
    Panel1: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel2: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  s, line, line2: string;
  sourcefile, targetfile: text;
  i: integer;


implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
 Opendialog1.Filter := 'HTML-Dokumente (*.html/*.htm)|*.HTML;*.HTM|Textdateien (*.txt)|*.TXT';
 Opendialog1.Execute;
 Edit1.Text:=Opendialog1.Filename;
 s:=Opendialog1.Filename;
 Repeat
  if s[length(s)]<>'.' then delete(s, length(s), 1); {Dateiextension bis zum Punkt lschen}
 Until s[length(s)]='.';
 Edit2.Text:=s+'ptn';  {automatischer Vorschlag fr Namen der Zieldatei}
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Savedialog1.Filter := 'Proteinkettendatei (*.ptn)|*.PTN';
 Savedialog1.Execute;
 if Savedialog1.Filename[length(Savedialog1.Filename)-3]+Savedialog1.Filename[length(Savedialog1.Filename)-2]+Savedialog1.Filename[length(Savedialog1.Filename)-1]+Savedialog1.Filename[length(Savedialog1.Filename)]<>'.ptn'
  then Savedialog1.Filename := Savedialog1.Filename+'.ptn';
 Edit2.Text:=Savedialog1.Filename;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
 Edit3.Enabled:=false;
 Edit4.Enabled:=false;
 Edit5.Enabled:=false;
 Label2.Enabled:=false;
 Label3.Enabled:=false;
 Label4.Enabled:=false;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
 Edit3.Enabled:=true;
 Edit4.Enabled:=true;
 Edit5.Enabled:=true;
 Label2.Enabled:=true;
 Label3.Enabled:=true;
 Label4.Enabled:=true;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 if Radiobutton1.Checked=true then
  begin
   if (Edit1.Text='') or (Edit1.Text='<Quelldatei>') then Application.Messagebox('Es wurde keine Quelldatei angegeben', 'Fehler', 48+0)
    else if (Edit2.Text='') or (Edit2.Text='<Zieldatei>') then Application.Messagebox('Es wurde keine Zieldatei angegeben', 'Fehler', 48+0)
    else
     begin
      Assignfile(sourcefile, Edit1.Text);
      Reset(sourcefile);
      Repeat
       Readln(sourcefile, line);
      Until line='ORIGIN      ';

      Assignfile(targetfile, Edit2.Text);
      Rewrite(targetfile);
      Append(targetfile);
      Repeat      {Zwischenrume entfernen...}
       Readln(sourcefile, line);
       line2 := '';
       i:=0;
       if line<>'//' then
        begin
         For i:=1 to length(line) do
          begin
           if (i>StrToInt(Edit3.Text)) and ((i-StrToInt(Edit3.Text)) mod (StrToInt(Edit4.Text)+StrToInt(Edit5.Text))<>0) then line2 := line2 + line[i];
          end;               {10}                          {10}                       {10}   {---11---}    {1}
         Write(targetfile, line2);
        end;
      Until line='//';

      Closefile(sourcefile);
      Closefile(targetfile);
      Application.MessageBox('Daten wurden erfolgreich extrahiert', 'Information', 64+0);
     end;
  end;
 if Radiobutton2.Checked=true then
  begin
   if (Edit1.Text='') or (Edit1.Text='<Quelldatei>') then Application.Messagebox('Es wurde keine Quelldatei angegeben', 'Fehler', 48+0)
    else if (Edit2.Text='') or (Edit2.Text='<Zieldatei>') then Application.Messagebox('Es wurde keine Zieldatei angegeben', 'Fehler', 48+0)
    else
     begin
      Assignfile(sourcefile, Edit1.Text);
      Reset(sourcefile);
      Repeat
       Readln(sourcefile, line);
       if length(line)<>0 then
        Repeat
         if line[length(line)]=' ' then delete(line, length(line), 1); {berflssige Leerzeichen entfernen, da diese nicht zwangslufig auftreten mssen}
        Until (length(line)=0) or (line[length(line)]<>' ');
      Until line='ORIGIN';

      Assignfile(targetfile, Edit2.Text);
      Rewrite(targetfile);
      Append(targetfile);
      Repeat      {Zwischenrume entfernen...}
       Readln(sourcefile, line);
       i:=0;
       Repeat
        if (line[i]=' ') or (line[i]='1') or (line[i]='2') or (line[i]='3')
          or (line[i]='4') or (line[i]='5') or (line[i]='6') or (line[i]='7')
          or (line[i]='8') or (line[i]='9') or (line[i]='0') then
           begin
            delete(line, i, 1);   {alles entfernen, was nicht Buchstabe ist}
            i:=i-1;   {da die folgenden Zeichen vorrcken}
           end;
        i:=i+1;
       Until i=length(line);  {Repeat, da for-Schleife wegen verndertem length(line) nicht mglich}
       if line<>'//' then Write(targetfile, line);
      Until line='//';

      Closefile(sourcefile);
      Closefile(targetfile);
      Application.MessageBox('Daten wurden erfolgreich extrahiert', 'Information', 64+0);
     end;
  end;
end;

end.
